VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CEditor"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit


' used to allow CDoc object set their interfaces to match program settings
Public BackColor As Long, ForeColor As Long
Public FontBold As Boolean, FontItalic As Boolean, FontName As String, FontSize As Integer
Public FontStrikethru As Boolean, FontUnderline As Boolean

' form used as the main user interface for the program
Private m_oFace As mdiEditor
' collection of all open CDoc objects
Private oOpenDocs As CDocs
Public Sub CenterForm(x_YourForm As Form)


    ' center the passed form to screen
    With x_YourForm
        .Move Abs(Screen.Width - .Width) \ 2, Abs(Screen.Height - .Height) \ 2
    End With ' x_YourForm
    
    
End Sub
Public Sub SaveAllFiles()


    ' invoke the saveall method of the oOpenDocs object
    oOpenDocs.SaveAll
    
    
End Sub
'  This method uses the dialog to set a new name for passed CDoc object then
'       invokes the object's .Save method
Public Sub SaveFileAs(YourDoc As CDoc)
   
    
    On Error GoTo SaveFileAs_Error
    
    
    Dim bDialogCanceled  As Boolean, sNewFileName As String, sDialogTitle As String
    
    ' setup dialog caption
    sDialogTitle = "Save '" & LCase$(YourDoc.Caption) & "' As"
    ' get the new filename from the 'save file' dialog
    
    Call ShowFileDialog(sNewFileName, bDialogCanceled, vSaveAs:=True, vDialogTitle:=sDialogTitle)

    ' if the user did not cancel the dialog then...
    If Not bDialogCanceled Then
        Screen.MousePointer = vbHourglass
        ' save the file
        With YourDoc
            .FileName = sNewFileName
            If Not .Save Then
                MsgBox "Error saving file '" & .FileName & "'."
            End If
        End With ' YourDoc
        Screen.MousePointer = vbDefault
    End If
    
    
Exit Sub
SaveFileAs_Error:
Select Case Err.Number
Case cdlCancel ' the user hit the cancel button in the 'open file' dialog
    bDialogCanceled = True
Case Else ' unexpected error so call application's main error handler
    If ProgramError Then Resume
End Select
Resume Next
End Sub
Public Sub NewFile()


    Dim TempDoc As CDoc
    
    ' start a new instance of CDoc
    Screen.MousePointer = vbHourglass
    Set TempDoc = oOpenDocs.MakeNew
    Screen.MousePointer = vbDefault


End Sub
Public Sub ShowFileDialog(sFileToUse As String, bDialogCanceled As Boolean, Optional vSaveAs As Variant, _
                                                    Optional vDialogTitle As Variant)


    On Error GoTo ShowSaveFileDialog_Error
        
        
    ' Here is how we use the MhCommonDialog as an 'open file' or 'save file' dialog box
    
    ' used to remember the last type of filter the user selected
    Static iSelectedFilterIndex As Byte
    
    With m_oFace!MhcommdlDemo
        ' do this so that we can tell if the user hit the cancel button (error 32755 is raised)
        .CancelError = True
        ' set the types of files which will appear in the 'filter' combo box
        .Filter = "Text Files|*.txt|Ini Files|*.ini|VB Files|*.cls;*.bas;*.frm;*.mak;*.vbp|All Files|*.*"
        ' if the calling routine passed a filename then make it the default
        If sFileToUse <> "" Then .FileName = sFileToUse
        ' select the type of 'filter' that the user used last time, if this is the first time then just select the first filter
        If iSelectedFilterIndex <> 0 Then
            .FilterIndex = iSelectedFilterIndex
        Else
            .FilterIndex = 1
        End If
        
        ' default to 'Open File' style
        If IsMissing(vSaveAs) Then vSaveAs = True
        Select Case vSaveAs
        Case False
            ' set the title if the calling procedure specified one otherwise set a default one
            If Not IsMissing(vDialogTitle) Then
                .DialogTitle = vDialogTitle
            Else
                .DialogTitle = "Open"
            End If
            ' show 'open file' dialog
            .Action = 1
        Case True
            ' set the title if the calling procedure specified one otherwise set a default one
            If Not IsMissing(vDialogTitle) Then
                .DialogTitle = vDialogTitle
            Else
                .DialogTitle = "Save"
            End If
            ' show 'save file' dialog
            .Action = 2
        End Select
        
        ' remember last filter type used
        iSelectedFilterIndex = .FilterIndex
        
        ' get the file name from the dialog
        sFileToUse = Trim$(.FileName)
    End With ' m_oFace
    
    
Exit Sub
ShowSaveFileDialog_Error:
Select Case Err.Number
Case cdlCancel ' the user hit the cancel button in the 'open file' dialog
    bDialogCanceled = True
Case Else ' unexpected error so call application's main error handler
    If ProgramError Then Resume
End Select
Resume Next
End Sub
Public Sub Startup()


    Screen.MousePointer = vbHourglass
    
    ' make new instance of CDocs object.  This object is used to manage CDoc objects
    Set oOpenDocs = New CDocs
    
    ' default the font properties to those used by mdi form picture box
    With m_oFace
        With !picVBXHolder
            BackColor = .BackColor
            ForeColor = .ForeColor
            FontBold = .FontBold
            FontItalic = .FontItalic
            FontName = .FontName
            FontSize = .FontSize
            FontStrikethru = .FontStrikethru
            FontUnderline = .FontUnderline
        End With ' picVBXHolder
    ' show the main program form
    .Show
    End With ' m_oFace
    
    Screen.MousePointer = vbDefault
    
    
End Sub
'  This procedure is called when other procedures run into unexpected errors.
'       The return value indicates whether the calling procedure should Resume or not.
'
'       True = Resume
'       False = Resume Next
Public Function ProgramError() As Boolean
    
    
    ' If this was more than just a demo actual error handling code would be here
    
    ' default to telling calling procedure not to
    '   Resume (instead just Resume Next)
    ProgramError = False
    

End Function
'  This method shows the application's about box
Public Sub ShowAbout()


    ' show the about box
    Screen.MousePointer = vbHourglass
    Load frmAbout
    frmAbout.Show
    Screen.MousePointer = vbDefault
    

End Sub
Public Sub OpenFile()


    Dim TempDoc As CDoc
    Dim sFileToLoad As String, bDialogCanceled As Boolean
    
    ' start a new instance of CDoc
    Screen.MousePointer = vbHourglass
    
    Set TempDoc = oOpenDocs.MakeNew
    ' ask the user for the file to load
    Call ShowFileDialog(sFileToLoad, bDialogCanceled)
    
    ' if the user did not cancel then load the file that they chose
    If Not bDialogCanceled Then Call TempDoc.LoadFile(sFileToLoad)
    
    Screen.MousePointer = vbDefault


End Sub
Public Sub ArrangeDocuments()


    ' call the arrange method of the main program interface
    Call m_oFace.Arrange(vbTileHorizontal)


End Sub
Public Sub ShowFontDialog(xEditBox As TextBox)


    On Error GoTo ShowFontDialog_Error
        
        
    ' Here is how we use the MhCommonDialog as an 'choose font' dialog box
    
    Dim bDialogCanceled As Boolean
    
    With m_oFace!MhcommdlDemo
        ' do this so that we can tell if the user hit the cancel button (error 32755 is raised)
        
        .CancelError = True
        ' show 'choose font' dialog
        .Action = 4
        
        ' if the user did not cancel then set the font properties of the passed text box
        If Not bDialogCanceled Then
            ' best to change font name first
            xEditBox.FontName = .FontName
            xEditBox.FontBold = .FontBold
            xEditBox.FontItalic = .FontItalic
            xEditBox.FontSize = .FontSize
            xEditBox.FontStrikethru = .FontStrikethru
            xEditBox.FontUnderline = .FontUnderline
        End If
        
    End With ' m_oFace!MhcommdlDemo
    
    
Exit Sub
ShowFontDialog_Error:
Select Case Err.Number
Case cdlCancel ' the user hit the cancel button in the 'open file' dialog
    bDialogCanceled = True
Case Else ' unexpected error so call application's main error handler
    If ProgramError Then Resume
End Select
Resume Next
End Sub
Public Sub ShowColorDialog(iNewColor As Long, bDialogCanceled As Boolean)


    On Error GoTo ShowColorDialog_Error
    
    
    ' Here is how we use the MhCommonDialog as an 'choose color' dialog box
    
    
    With m_oFace!MhcommdlDemo
        ' do this so that we can tell if the user hit the cancel button (error 32755 is raised)
        .CancelError = True
        ' show 'choose color' dialog
         .Action = 3
        ' if the user did not cancel then set the iNewColor parameter
        If Not bDialogCanceled Then iNewColor = .Color
    End With ' m_oFace!MhcommdlDemo
    
    
Exit Sub
ShowColorDialog_Error:
Select Case Err.Number
Case cdlCancel ' the user hit the cancel button in the 'open file' dialog
    bDialogCanceled = True
Case Else ' unexpected error so call application's main error handler
    If ProgramError Then Resume
End Select
Resume Next
End Sub
Public Sub ShowUsingMhCMDialog()

    
    ' show the form which tells the user about using the MhCMDialog control
    Screen.MousePointer = vbHourglass
    Load frmUsingMhCMDialog
    Screen.MousePointer = vbDefault
    frmUsingMhCMDialog.Show vbModal
    

End Sub
Public Sub RemoveDocument(YourDoc As CDoc)

    
    ' call oOpenDocs to remove this CDoc instance
    Call oOpenDocs.Remove(YourDoc)
    

End Sub
Public Sub CloseDown()


    ' clear reference to the oOpenDocs object
    Set oOpenDocs = Nothing

    Call DemoMain.ProgramExit
    
    
End Sub
Public Property Get Face() As Form


    ' return reference to form used as interface for application
    Set Face = m_oFace
    
    
End Property
Public Property Set Face(oNewFace As Form)


    ' set reference to form used as interface for application
    Set m_oFace = oNewFace
    
    
End Property
Public Function PrintDocument(YourDoc As CDoc) As Boolean

    
    ' your print routine would be implemented here
        
    MsgBox "I did not get quite this far"


End Function
